Subject: Re: scripting elevated privilege on Windows 7
From: Robert Pendell <[email-masked]>
To: [email-masked]
Date: Sat, 17 Apr 2010 13:38:24 -0400
List-Id: <cygwin.cygwin.com>

On Fri, Apr 16, 2010 at 12:33 PM wrote:
> Thank you Robert Pendell! I wrote this shell script. Any suggestions
> for optimization?
>
> #!/bin/bash
> if [ $# -eq 1 ]
> then
>        echo "Usage: elev program arg1 arg2 ..."
>        exit 1
> fi
> prog="$1"
> shift
> exec cygstart --action=runas `which "$prog"` "$@"
>
>

It looks fine (beyond the quoting) but there is an error.

In your if test you check the number of parameters and check to see if
there is exactly one then throw the message.  It should be zero rather
than one because it doesn't count the current process name.

On that note I might suggest replacing 'elev' in the Usage text with
$0 so it can reflect the file it was called as.

On and while quoting works there are better ways as Eric had already
suggested.  I didn't bother changing it but the following script works
well and is tested.

#!/bin/bash
if [ $# -eq 0 ]
then
     echo "Usage: $0 program arg1 arg2 ..."
     exit 1
fi
prog="$1"
shift
exec cygstart --action=runas `which "$prog"` "$@"

On that note if you plan on reusing the script on xp or older (for
portability) then you might want to check the platform os so that you
don't use that action setting on them.  The runas action is only valid
on Windows Vista and Windows 7 since that is when it was added.

Robert Pendell
[email-masked]
CAcert Assurer
"A perfect world is one of chaos."

--
Problem reports:       http://cygwin.com/problems.html
FAQ:                   http://cygwin.com/faq/
Documentation:         http://cygwin.com/docs.html
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple